### Steve Dodson
### August 24, 2000
### Parses a NCSA style log.  Reads a filter file (filter.dat)
### to see if any IPs should be skipped over when reporting.
### Creates an HTML file (NCSA_log.html) with the results.
### This version is MEANT ONLY for logs that record the following:
### IP, Time, File Hit, Error Code, and Bytes Transferred.

print "To use this script, enter any IP addresses or domain names you\n";
print "want filtered into the file \"Filter.dat\"\n\n";
print "Enter the log file to parse.\nInclude the path if necessary.\nPress 'Q' to quit.\n";
print "Filename: ";
$path = <STDIN>;
chomp ($path);
exit if ($path eq "q" | $path eq "Q");

### Check to see if the file exists
if ( (-e $path) )  
{
open (INFILE, "$path") || die error("Failed to open the log file specified");
open (OUTFILE, ">NCSA_log.html") || die error("Unable to create the output file");
open (FILTER, "filter.dat") || die error("Failed to open the filter file");
while (<FILTER>)
{
   chomp($_);
   @filterArray = split(/\+/, $_);
}
$mainCounter = 0;
OUTER: while (<INFILE>)
{
   @quoteSplit = split (/\"/, $_);
   $quoteCounter = 0;
    foreach ( @quoteSplit )
   {
      chomp($_);
      if ($quoteCounter == 0)
      {
         splitIP();
      }
      elsif ($quoteCounter == 1)
      {
         splitRequest ();
      }
      elsif ($quoteCounter == 2)
      {
         splitFileCode ();
      }
      else
      {
         # Do nothing
      }

   $quoteCounter ++;
   }
   $mainCounter ++;
}
### Print HTML header and the table header
select(OUTFILE);
print <<HERE_DOC;
<HTML>
<HEAD><TITLE>Parsed NCSA style log</TITLE></HEAD>
<BODY BGCOLOR="white">
<!-- Log Parser by Steve Dodson: http://dodson.morpheus.net -->

<TABLE BORDER="1" ALIGN="Center">
<TR BGCOLOR="Silver" ALIGN="Center">
<TD><B>IP</B></TD>
<TD><B>Time</B></TD>
<TD><B>File Hit</B></TD>
<TD><B>Error Code</B></TD>
<TD><B>Bytes Transferred</B></TD>
</TR>
HERE_DOC

$HTMLCounter = 0;
foreach(@finalIP)
{
   print "<TR>\n";
   print "<TD>$finalIP[$HTMLCounter]</TD>\n";
   print "<TD>$finalTime[$HTMLCounter]</TD>\n";
   print "<TD>$finalFile[$HTMLCounter]</TD>\n";
   print "<TD>$finalFileCode[$HTMLCounter]</TD>\n";
   print "<TD>$finalFileSize[$HTMLCounter]</TD>\n";
   print "</TR>\n";
   $HTMLCounter++;
}

print "</TABLE>";
print "\n<BR><B>Number of hits:</B> $mainCounter<BR>";
print "\n<B>Filtered IPs or Domains: </B><BR>";
$filterPrintCntr = 0;

foreach ( @filterArray )
{
   $counter = $filterPrintCntr + 1;
   print "$counter.) $filterArray[$filterPrintCntr]<BR>";
   $filterPrintCntr++;
}
print "\n</BODY></HTML>";
select (STDOUT);

sub splitIP
{
   s#[\[\]]*##g;
   @IPSpaceSplit = split (/ /, $_);
   ### --------------------------------------------------------------------------------------
   ### finalIP=Remote User's IP   
   ### finalTime=Time Accessed   
   ### --------------------------------------------------------------------------------------

   $filterCounter = 0;
   foreach (@filterArray)
   {
      if ($IPSpaceSplit[0] eq $filterArray[$filterCounter])
      {
         next OUTER;
      }
      $filterCounter ++;
   }

   $finalIP[$mainCounter] = $IPSpaceSplit[0];   
   $finalTime[$mainCounter] = $IPSpaceSplit[3];
}
} 
else
{
  error("The log file specified does not exist at this location");
}
sub splitRequest
{
   @requestSplit = split(/ /, $_);
   $finalFile[$mainCounter] = $requestSplit[1];
}

sub splitFileCode
{
   ### ---------------------------------------------------------------------
   ### finalFileCode=Error Code - see below
   ### [200-No error , 300-Redirection, 400-Client-side error, 500-Server-side error]
   ### finalFileSize=Bytes Sent
   ### ---------------------------------------------------------------------
   @fileCodeSplit = split (/ /, $_);
   $finalFileCode[$mainCounter] = $fileCodeSplit[1];
   $finalFileSize[$mainCounter] = $fileCodeSplit[2];
}

sub error
{
  print "\n\nAN ERROR:\"$_[0]\" has terminated this script.\n";
  print "Please check to see that the file exists and that\n";
  print "it is not in use by another process\n";
  exit;
}
close INFILE;
close OUTFILE;
close FILTER;